/*------------------------------------------------------------------------------

 Author:  IAP GmbH
 Puprose: Demo code for OOABL pattern presentation
          This user object is used in the userbuilder object

 Notes:
 - The setter are private
   The values are pulled from the builder

------------------------------------------------------------------------------*/

USING 01_builder.UserBuilder.

CLASS 01_builder.User:

/*---------------------------------Definitions----------------------------------*/

  /* required */
  DEFINE PUBLIC PROPERTY cFirstName AS CHARACTER NO-UNDO 
    PUBLIC GET.
    PRIVATE SET.
  DEFINE PUBLIC PROPERTY cLastName AS CHARACTER NO-UNDO /* required */
    PUBLIC GET.
    PRIVATE SET.

  /* optional */
  DEFINE PUBLIC PROPERTY iAge AS INTEGER NO-UNDO
    PUBLIC GET.
    PRIVATE SET.
  DEFINE PUBLIC PROPERTY cPhone AS CHARACTER NO-UNDO 
    PUBLIC GET.
    PRIVATE SET.
  DEFINE PUBLIC PROPERTY cAddress AS CHARACTER NO-UNDO
    PUBLIC GET.
    PRIVATE SET.

/*-------------------------------- Constructor----------------------------------*/

  // The builder is here input parameter, contains all needed properties 
  CONSTRUCTOR PUBLIC User(builder AS UserBuilder):
    THIS-OBJECT:cFirstName = builder:cFirstName.
    THIS-OBJECT:cLastName  = builder:cLastName.
    THIS-OBJECT:iAge       = builder:iAge.
    THIS-OBJECT:cPhone     = builder:cPhone.
    THIS-OBJECT:cAddress   = builder:cAddress.
  END CONSTRUCTOR.

END CLASS.
