
/*----------------------------------------------------------------------
    File        : 03_multiton/start.p
    Purpose     : starting the Multiton Pattern example.
    Author(s)   : Xara Arnold, Klaus Erichsen
    
  This demo program will call a multiton object. The getInstance method
  is static. It creates internally the dynamic part of multiton object.
  ----------------------------------------------------------------------*/

USING 03_multiton.multiCust.

DEFINE VARIABLE oMultiCust AS multiCust NO-UNDO.
DEFINE VARIABLE cName1 AS CHARACTER NO-UNDO.
DEFINE VARIABLE iNum1  AS INTEGER NO-UNDO.
DEFINE VARIABLE cName2 AS CHARACTER NO-UNDO.
DEFINE VARIABLE iNum2  AS INTEGER NO-UNDO.


/* We call a multiton 4 times. The first call with a given customer number
   (e.g. 1537) will create an entry in the multiton. The second call
   will use this existing entry. */ 
oMultiCust = 03_multiton.multiCust:getInstance(1537).
cName1 = oMultiCust:cCustName.
oMultiCust = 03_multiton.MultiCust:getInstance(1).
cName2 = oMultiCust:cCustName.

oMultiCust = 03_multiton.multiCust:getInstance(1537).
iNum1  = oMultiCust:iCustNum.
oMultiCust = 03_multiton.MultiCust:getInstance(1).
iNum2  = oMultiCust:iCustNum.

MESSAGE "Used multiton object to get 2 customer instances:" SKIP
        "1." cName1 " (" iNum1 ")" SKIP 
        "2." cName2 " (" iNum2 ")"  
VIEW-AS ALERT-BOX.
