
 /*------------------------------------------------------------------------
    File        : 04_lazy_loading/lazy_initialization/Order
    Purpose     : Example for the Lazy Loading Design Pattern
    Author(s)   : michael.barfs
    Created     : Thu Mar 01 09:15:27 CET 2018
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.

CLASS 04_lazy_loading.lazy_initialization.Order:

/*---------------------------------Definitions----------------------------------*/

  DEFINE PUBLIC PROPERTY OrderDate AS DATE NO-UNDO INITIAL ?
    PUBLIC GET():
      IF OrderDate = ? THEN DO:
        DEFINE VARIABLE iOrderNum AS INTEGER NO-UNDO.
        iOrderNum = THIS-OBJECT:OrderNum.
        DEFINE BUFFER bOrder FOR Order.
        FIND FIRST bOrder WHERE bOrder.Ordernum = iOrderNum NO-LOCK NO-ERROR.
        IF AVAILABLE bOrder THEN
          OrderDate = bOrder.OrderDate.
      END.
      RETURN OrderDate.
    END GET.
    PRIVATE SET.

  DEFINE PUBLIC PROPERTY OrderNum AS INTEGER NO-UNDO
    PUBLIC GET.
    PRIVATE SET.

/*-------------------------------- Constructor----------------------------------*/

  CONSTRUCTOR PUBLIC Order(iOrderNum AS INTEGER):
    THIS-OBJECT:OrderNum = iOrderNum.
  END CONSTRUCTOR.

/*----------------------------------End Class-----------------------------------*/

END CLASS.