
/*------------------------------------------------------------------------
    File        : 04_lazy_loading/lazy_initialization/start.p
    Purpose     : starting the Lazy Loading Pattern example.
    Author(s)   : Xara Arnold
  ----------------------------------------------------------------------*/

USING 04_lazy_loading.lazy_initialization.CustomerOfInvoice.
USING 04_lazy_loading.lazy_initialization.Order.

/*---------------------------------Definitions----------------------------------*/

DEFINE VARIABLE oCustomerInvoice AS CustomerOfInvoice NO-UNDO.
DEFINE VARIABLE iInvoiceNum AS INTEGER NO-UNDO.
DEFINE VARIABLE iCustomerNum AS INTEGER NO-UNDO.
DEFINE VARIABLE cCustomerName AS CHARACTER NO-UNDO.

DEFINE VARIABLE oOrder AS Order NO-UNDO.
DEFINE VARIABLE iOrderNum AS INTEGER NO-UNDO.
DEFINE VARIABLE dOrderDate AS DATE NO-UNDO.

/*------------------------------------------------------------------------------
  1. Example for Lazy Loading in the Lazy Initialization variant
------------------------------------------------------------------------------*/

oCustomerInvoice = NEW 04_lazy_loading.lazy_initialization.CustomerOfInvoice(10).
cCustomerName = oCustomerInvoice:cCustomerName.
iCustomerNum = oCustomerInvoice:iCustomerNum.
iInvoiceNum = oCustomerInvoice:iInvoiceNum.

MESSAGE "1. Example for Lazy Loading in the Lazy Initialization variant:" SKIP
        "- Customer of Invoice -" SKIP
        "Customer Name: " cCustomerName SKIP
        "Customer Number: " iCustomerNum SKIP
        "Invoice Number: " iInvoiceNum
VIEW-AS ALERT-BOX.

/*------------------------------------------------------------------------------
  2. Example for Lazy Loading in the Lazy Initialization variant
------------------------------------------------------------------------------*/

oOrder = NEW 04_lazy_loading.lazy_initialization.Order(10).
iOrderNum = oOrder:OrderNum.
dOrderDate = oOrder:OrderDate.

MESSAGE "2. Example for Lazy Loading in the Lazy Initialization variant:" SKIP
        "- Order Date -" SKIP
        "Order Number: " iOrderNum SKIP
        "Order Date: " dOrderDate
VIEW-AS ALERT-BOX.

