 
 /*------------------------------------------------------------------------
    File        : 06_Factory/bikeWheeler
    Purpose     : Create a cool BIKE object
    Author(s)   : klaus.erichsen
    
    This is one implementation of the iWheeler interface.
    There are common methods (like buildWheeler) and specifig (like addPedal).
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 06_Factory.iWheeler.


CLASS 06_Factory.bikeWheeler IMPLEMENTS 06_Factory.iWheeler: 

  DEFINE PUBLIC PROPERTY cColor        AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cType         AS CHARACTER NO-UNDO GET. SET.
  DEFINE PUBLIC PROPERTY cBuildResult  AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cFeatures     AS CHARACTER NO-UNDO GET. SET. 


  METHOD PUBLIC VOID buildWheeler(  ):
    // Call some bike specific stuff
    addPedal().
    cBuildResult = "I build a bike".
    cColor = "green".
    cType  = "bike".
  END METHOD.

  METHOD PUBLIC CHARACTER driveTest( INPUT cLevel AS CHARACTER ):
    // Run various tests somewhere in the area
    RETURN "Did bike test drive on level: " + cLevel.
  END METHOD.

  METHOD PUBLIC LOGICAL addPedal(  ):
    // Add a pair of glowing pedals to the bike
    cFeatures = "Professional races pedals".
    RETURN TRUE.
  END METHOD.

END CLASS.
