 
 /*------------------------------------------------------------------------
    File        : 06_Factory/carWheeler
    Purpose     : Create a CAR object
    Author(s)   : klaus.erichsen

    This is one implementation of the iWheeler interface.
    There are common methods (like buildWheeler) and specifig (like addSteeringWheel).
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 06_Factory.iWheeler.


CLASS 06_Factory.carWheeler IMPLEMENTS iWheeler: 

  DEFINE PUBLIC PROPERTY cColor        AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cType         AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cBuildResult  AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cFeatures     AS CHARACTER NO-UNDO GET. SET. 

  METHOD PUBLIC VOID buildWheeler(  ):
    // Call some car specific stuff
    addSteeringWheel().
    cBuildResult = "I build a car".
    cColor = "black".
    cType  = "car".
  END METHOD.

  METHOD PUBLIC CHARACTER driveTest( INPUT cLevel AS CHARACTER ):
    // Run various tests somewhere in the area
    RETURN "Did car test drive on level: " + cLevel.
  END METHOD.

  METHOD PUBLIC LOGICAL addSteeringWheel(  ):
    // Add a nice steering wheel to the car
    cFeatures = "Nice wooden steering wheel".
    RETURN TRUE.
  END METHOD.

END CLASS.
