 
 /*------------------------------------------------------------------------
    File        : 06_Factory/fWheeler
    Author(s)   : klaus.erichsen

  This class is a factory for various types of wheelers.
  It gives back the created wheeler in an object of type of the interface. 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 06_Factory.iWheeler.
USING 06_Factory.carWheeler.
USING 06_Factory.bikeWheeler.


CLASS 06_Factory.fWheeler:
    
  CONSTRUCTOR PUBLIC fWheeler ():
    // Some important stuff here          
  END CONSTRUCTOR.


  // Create a car, bike or what else...
  METHOD PUBLIC iWheeler createWheeler ( cWheelerType AS CHARACTER ):
    DEFINE VARIABLE oWheeler AS iWheeler NO-UNDO.
    
    /* Instantiate various object types (which implement wheeler interface). */ 
    CASE cWheelerType:
      WHEN "Car"  THEN oWheeler = NEW carWheeler().
      WHEN "Bike" THEN oWheeler = NEW bikeWheeler().
      OTHERWISE DO: 
        MESSAGE "Uups, unknown wheeler type: " cWheelerType
          VIEW-AS ALERT-BOX INFORMATION. 
        RETURN ERROR.
      END. 
    END CASE.
    
    // Start the wheeler building process     
    oWheeler:buildWheeler().
    RETURN oWheeler.
    
  END METHOD.

END CLASS.