
/*------------------------------------------------------------------------
    File        : 06_Factory/start.p
    Author(s)   : Klaus Erichsen
    
    This program uses the wheeler factory (fwheeler) to create two wheelers, 
    a car and a bike.
  ----------------------------------------------------------------------*/

USING 06_Factory.iWheeler.
USING 06_Factory.fWheeler.

/*---------------------------------Definitions----------------------------------*/


DEFINE VARIABLE ofWheeler  AS fWheeler NO-UNDO.

DEFINE VARIABLE oWheeler1  AS iWheeler NO-UNDO.
DEFINE VARIABLE oWheeler2  AS iWheeler NO-UNDO.


/*---------------------------------Main Block-----------------------------------*/

// First, create the factory
ofWheeler = NEW fWheeler().
// Then create two wheelers
oWheeler1  = ofWheeler:createWheeler("bike").
oWheeler2  = ofWheeler:createWheeler("car").

// Get some information from the wheelers
MESSAGE " - 1st WHeeler - " SKIP
        "Result of building wheeler: " oWheeler1:cBuildResult SKIP 
        "Color in Object: " oWheeler1:cColor SKIP 
        "DriveTest: " oWheeler1:driveTest("moderate") SKIP
        "Features: "  oWheeler1:cFeatures SKIP (1)
        
        " - 2nd WHeeler - " SKIP
        "Result of building wheeler: " oWheeler2:cBuildResult SKIP 
        "Color in Object: " oWheeler2:cColor SKIP 
        "DriveTest: " oWheeler2:driveTest("moderate") SKIP
        "Features: "  oWheeler2:cFeatures 
  VIEW-AS ALERT-BOX INFORMATION TITLE "Build wheeler result".
