 
 /*------------------------------------------------------------------------
    File        : 07_Proxy/proxySoapService.cls
    Purpose     : Proxy class for Soap Service
    Author(s)   : klaus.erichsen

  This class is the proxy to the soap interface.
  It will check the user rights and force a secure transmission.

  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 06_Factory.iWheeler.
USING 06_Factory.carWheeler.
USING 06_Factory.bikeWheeler.

CLASS 07_Proxy.proxySoapService:

  DEFINE PUBLIC PROPERTY cURL            AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cProtocol       AS CHARACTER NO-UNDO GET. SET. 
  DEFINE PUBLIC PROPERTY cConnectResult  AS CHARACTER NO-UNDO GET. SET. 

  DEFINE VARIABLE oSoapServices  AS 07_Proxy.soapService NO-UNDO.
  
    
  // Create the service object and force https
  CONSTRUCTOR PUBLIC proxySoapService ():
    IF testUserRights() = TRUE THEN DO:
      oSoapServices = NEW 07_Proxy.soapService().
      oSoapServices:cProtocol = "SOAP".
      oSoapServices:lUseHttps = TRUE.
    END.
    ELSE RETURN ERROR.
  END CONSTRUCTOR.

  // Connect target URL
  METHOD PUBLIC VOID connectURL ( ).
    oSoapServices:cURL = THIS-OBJECT:cURL.
    IF oSoapServices:connectURL() THEN DO:
      cConnectResult = "Everything OK, connected : " + THIS-OBJECT:cURL.
    END.
    ELSE RETURN ERROR. 
  END METHOD.
  
  METHOD PRIVATE LOGICAL testUserRights ():
    // Do some sophisticated right checks
    RETURN TRUE.
  END.

END CLASS.